﻿/*
** randomWord 产生任意长度随机字母数字组合
** randomFlag-是否任意长度 
*  min-任意长度最小位[固定位数] 
*  max-任意长度最大位
** xuanfeng 2014-08-28
*/
 
function randomWord(randomFlag, min, max){
    var str = "",
        range = min,
        arr = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9','A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];
 
    // 随机产生
    if(randomFlag){
        range = Math.round(Math.random() * (max-min)) + min;
    }
    for(var i=0; i<range; i++){
        pos = Math.round(Math.random() * (arr.length-1));
        str += arr[pos];
    }
    return str;
}
/**       
 * 对Date的扩展，将 Date 转化为指定格式的String       
 * 月(M)、日(d)、12小时(h)、24小时(H)、分(m)、秒(s)、周(E)、季度(q) 可以用 1-2 个占位符       
 * 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)       
 * eg:       
 * (new Date()).pattern("yyyy-MM-dd") ==> 2006-07-02      
 * (new Date()).pattern("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423       
 * (new Date()).pattern("yyyy-MM-dd E HH:mm:ss") ==> 2009-03-10 二 20:09:04       
 * (new Date()).pattern("yyyy-MM-dd EE hh:mm:ss") ==> 2009-03-10 周二 08:09:04       
 * (new Date()).pattern("yyyy-MM-dd EEE hh:mm:ss") ==> 2009-03-10 星期二 08:09:04       
 * (new Date()).pattern("yyyy-M-d h:m:s.S") ==> 2006-7-2 8:9:4.18       
 */          
Date.prototype.pattern=function(fmt) {           
    var o = {           
    "M+" : this.getMonth()+1, //月份           
    "d+" : this.getDate(), //日           
    "h+" : this.getHours()%12 == 0 ? 12 : this.getHours()%12, //小时           
    "H+" : this.getHours(), //小时           
    "m+" : this.getMinutes(), //分           
    "s+" : this.getSeconds(), //秒           
    "q+" : Math.floor((this.getMonth()+3)/3), //季度           
    "S" : this.getMilliseconds() //毫秒           
    };           
    var week = {           
    "0" : "/u65e5",           
    "1" : "/u4e00",           
    "2" : "/u4e8c",           
    "3" : "/u4e09",           
    "4" : "/u56db",           
    "5" : "/u4e94",           
    "6" : "/u516d"          
    };           
    if(/(y+)/.test(fmt)){           
        fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));           
    }           
    if(/(E+)/.test(fmt)){           
        fmt=fmt.replace(RegExp.$1, ((RegExp.$1.length>1) ? (RegExp.$1.length>2 ? "/u661f/u671f" : "/u5468") : "")+week[this.getDay()+""]);           
    }           
    for(var k in o){           
        if(new RegExp("("+ k +")").test(fmt)){           
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));           
        }           
    }           
    return fmt;           
} 
/******
 * 文件上传函数
 * 
 */
function createUpload(url,upid,callBack) {
	var wt=plus.nativeUI.showWaiting();
	var task = plus.uploader.createUpload(uploadImgServer, 
		{ method:"POST",blocksize:204800,priority:100 },
		function ( t, status ) {
			// 上传完成
			if ( status == 200 ) { 
				plus.nativeUI.toast( "上传成功!");
				callBack(t.responseText);
				wt.close();
			wt.close();
			} else {
				wt.close();
				plus.nativeUI.toast( "上传失败:" + status );
			}
		}
	);
	plus.zip.compressImage({
			src:url,
			dst:"_doc/pototemp.jpg",
			quality:zip_quality,
			overwrite:true
		},
		function() {
			task.addFile("_doc/pototemp.jpg", {key:"imgData"} );
			task.addData( "upImg", upid);
			task.start();
		},function(error) {
			console.log("压缩失败!");
	});
	
	//task.addEventListener( "statechanged", onStateChanged, false );
	
}
/*
 * 
 * 获取字符串中json字符串
 * 
 * 
 */
function getImgPath(string)
{
	var temp=string.substr(string.indexOf("{"),string.indexOf("}"));
	temp=temp.replace("{","");
	temp=temp.replace("}","");
	return temp;
}
// 拍照添加文件
 function getImage(callBack) {
    var cmr = plus.camera.getCamera(); 
    cmr.captureImage( function ( p ) {        
        plus.io.resolveLocalFileSystemURL( p, function ( entry ) {    
            if(files.length<2){  
                  var localurl = entry.toLocalURL();//把拍照的目录路径，变成本地url路径，例如file:///........之类的。
                  		createUpload(localurl,memberInfo.id+randomWord(false,4,0),callBack);//上传图片
                    } 
                });   
    },function( error ) {
            console.log( "图像获取失败: "+error.message );
        }  
    );   
} 
// 从相册添加文件 
function appendByGallery(callBack){
    plus.gallery.pick(function(path){
        createUpload(path,memberInfo.id+randomWord(false,4,0),callBack);//上传图片
    });
}
//年龄转换为出生日期
function AgeToDate(str){
	var strDate=(new Date().getFullYear()-str)+"/"+(new Date().getMonth()+1)+"/"+new Date().getDate();
	return new Date(new Date(strDate));
}
//出生日期转换为年龄
function DateToAge(birthday){
	 var age=-1;
	 var today=new Date();
	 var todayYear=today.getFullYear();
	 var todayMonth=today.getMonth()+1;
	 var todayDay=today.getDate();
	 var birthday=parseDate(birthday);
	 if(parseDate(birthday)!='时间转换发生错误！')
	 {
	 birthdayYear=birthday.getFullYear();
	 birthdayMonth=birthday.getMonth();
	 birthdayDay=birthday.getDate();
	 if(todayYear-birthdayYear<0)
	 {
	  alert("出生日期选择错误!");
	 }
	 else
	 {
	  if(todayMonth*1-birthdayMonth*1<0)
	  {
	    age = (todayYear*1-birthdayYear*1)-1;
	  }
	  else
	  {
	    if(todayDay-birthdayDay>=0)
	    {//alert(thisDay+'-'+brithd+"_ddd");
	      age = (todayYear*1-birthdayYear*1);
	    }
	    else
	    {
	      age = (todayYear*1-birthdayYear*1)-1;
	    }
	  }
	 }
	 return age*1;
	 }
	 else
	 {
	 return -1;
	 }
}